import {NgbDateStruct} from './ngb-date-struct';

/**
 * Context for the datepicker 'day' template in case you want to override the default one
 */
export interface DayTemplateContextNOA11Y {
  /**
   * Month currently displayed by the datepicker
   */
  currentMonth: number;

  /**
   * Date that corresponds to the template
   */
  date: NgbDateStruct;

  /**
   * True if current date is disabled
   */
  disabled: boolean;

  /**
   * True if current date is focused
   */
  focused: boolean;

  /**
   * True if current date is selected
   */
  selected: boolean;

  /**
   * True if current date is today
   */
  isToday: boolean;

  /**
   * True if current date is a weekend day
   */
  isWeekend: boolean;

  /**
   * True if current date is a weekend day
   */
  isDayPast: boolean;

    /**
   * True if current date is a tax deadlines
   */
  isFiscalDay: boolean;

    /**
   * True if current date is an holiday
   */
  isHoliday?: boolean;
}
