import {ChangeDetectionStrategy, Component, Input} from '@angular/core';
import {NgbDateStruct} from './ngb-date-struct';

@Component({
  selector: '[ngbFidDatepickerDayView]',
  changeDetection: ChangeDetectionStrategy.OnPush,
  host: {
    'class': 'btn-secondary',
    '[class.bg-primary]': 'selected',
    '[class.text-white]': 'selected',
    '[class.text-muted]': 'isMuted()',
    '[class.outside]': 'isMuted()',
    '[class.active]': 'focused',
    '[class.is-today]': 'isToday',
    '[class.is-holiday]' : 'isHoliday',
    '[class.is-weekend]': 'isWeekend',
    '[class.is-daypast]': 'isDayPast',
    '[class.is-fiscal]' : 'isFiscalDay'
  },

  templateUrl: './datepicker-day-view.html',
  styleUrls: ['./datepicker-day-view.scss'],

})
export class NgbDatepickerDayViewNOA11Y {
  @Input() currentMonth: number;
  @Input() date: NgbDateStruct;
  @Input() disabled: boolean;
  @Input() focused: boolean;
  @Input() selected: boolean;

  @Input() startDateEnabled: any;
  @Input() endDateEnabled: any;

  @Input() isToday: boolean;
  @Input() isWeekend: boolean;
  @Input() isDayPast: boolean;
  @Input() taxDeadlines: any;
  @Input() isFiscalDay: boolean;
  @Input() isHoliday : boolean;

  isMuted() { return !this.selected && (this.date.month !== this.currentMonth || this.disabled); }

  abilitaGiorni(data) {
    let startDate, endDate;
    let buffer = new Date(data.year, data.month - 1, data.day);

    if (this.startDateEnabled instanceof Date) {
      startDate = new Date(this.startDateEnabled.getFullYear(), this.startDateEnabled.getMonth(), this.startDateEnabled.getDate());
      endDate = new Date(this.endDateEnabled.getFullYear(), this.endDateEnabled.getMonth(), this.endDateEnabled.getDate());
    } else {
      startDate = new Date(this.startDateEnabled.year, this.startDateEnabled.month - 1, this.startDateEnabled.day);
      endDate = new Date(this.endDateEnabled.year, this.endDateEnabled.month - 1, this.endDateEnabled.day);
    }

    if (startDate && endDate) {
      return (startDate <= buffer && buffer <= endDate);
    } else {
      return true;
    }
  }

  labelDay(data){
    let result;
    let weekdays = ['Domenica', 'Lunedì', 'Martedì', 'Mercoledì', 'Giovedì', 'Venerdì', 'Sabato'];
    result = weekdays[new Date(data.year, data.month - 1, data.day).getDay()] + ' ' + data.day;
    return result;

  }

}
