import { ChangeDetectionStrategy, Component, Input, OnInit, OnChanges, SimpleChanges, OnDestroy } from '@angular/core';
import { NgbMeseStruct } from './ngb-mese-struct';
import { NgbYearStruct } from './ngb-year-struct';
import { NgbDatepickerServiceNOA11Y } from './datepicker-service';
import { Subscription } from 'rxjs';
import { DatepickerViewModel } from './datepicker-view-model';


@Component({
  selector: '[ngbFidDatepickerReplyMonthView]',
  changeDetection: ChangeDetectionStrategy.OnPush,
  host: {
    'class': 'btn-secondary-month',
    '[class.bg-primary]': 'selected',
    '[class.text-white]': 'selected',
    '[class.text-muted]': 'isMuted()',
    '[class.outside]': 'isMuted()',
    '[class.active]': 'focused',
    '[class.is-current]': 'isCurrent'
  },

  templateUrl: './datepicker-reply-month-view.html',
  styleUrls: ['./datepicker-reply-month-view.scss'],

})
export class NgbDatepickerReplyMonthViewNOA11Y implements OnInit, OnDestroy {
  
  @Input() currentMonth: number;
  @Input() mese: NgbMeseStruct;
  @Input() year: number;
  @Input() disabled: boolean;
  @Input() focused: boolean;
  @Input() selected: boolean;

  @Input() startDateEnabled: any;
  @Input() endDateEnabled: any;

  isCurrent : boolean = false;

  private _sub : Subscription;

  ngOnDestroy(): void {
    // if(this._sub) {
    //   this._sub.unsubscribe();
    // }
  }

  ngOnInit() {
    const now = new Date();
    // console.info('onInit month', this.mese.number, (now.getMonth()+1), this.year, now.getFullYear(), this.mese.number === (now.getMonth()+1), this.year === now.getFullYear());
    // console.info('onInit month', typeof (this.mese.number), typeof ((now.getMonth()+1)), typeof (this.year), typeof (now.getFullYear()), this.mese.number === (now.getMonth()+1), this.year === now.getFullYear());
    // console.info('onInit month selected', this.selected);
    this.isCurrent = this.mese.number === (now.getMonth()+1) && this.year === now.getFullYear();
    this.setSelected(this.service._model$.getValue());
  }

  isMuted() { return false };

  abilitaMesi(data) {

    return (((this.startDateEnabled.year == this.year && this.startDateEnabled.month <= data.number) || 
    (data.number < this.startDateEnabled.month && this.startDateEnabled.year < this.year) || 
    (this.startDateEnabled.month <= data.number && this.startDateEnabled.year <= this.year))
    && ((data.number <= this.endDateEnabled.month && this.year <= this.endDateEnabled.year) || (data.number > this.endDateEnabled.month && this.year < this.endDateEnabled.year)))
    
  }

  setSelected(model : DatepickerViewModel) {
    // console.info('selected:month', model, this.mese, this.year);
    if(model && model.selectedDate) {
      this.selected = (this.mese && this.mese.number === model.selectedDate.month) && this.year === model.selectedDate.year;
      return;
    }
    // console.info('selected:month no current, checking first');
    if(model && model.firstDate) {
      this.selected = (this.mese && this.mese.number === model.firstDate.month) && this.year === model.firstDate.year;
      return;
    }
  }

  constructor(private service : NgbDatepickerServiceNOA11Y) {
    // this._sub = this.service.model$.subscribe(this.setSelected);
  }
  // isMuted() { return !this.selected && (this.mese.number !== this.currentMonth || this.disabled); }
  
}
