import { ChangeDetectionStrategy, Component, Input, OnInit, OnDestroy } from '@angular/core';
import { NgbYearStruct } from './ngb-year-struct';
import { NgbDatepickerServiceNOA11Y } from './datepicker-service';
import { Subscription } from 'rxjs';
import { DatepickerViewModel } from './datepicker-view-model';

@Component({
  selector: '[ngbFidDatepickerReplyYearsView]',
  changeDetection: ChangeDetectionStrategy.OnPush,
  host: {
    'class': 'btn-secondary-years',
    '[class.bg-primary]': 'selected',
    '[class.text-white]': 'selected',
    '[class.text-muted]': 'isMuted()',
    '[class.outside]': 'isMuted()',
    '[class.active]': 'focused',
    '[class.is-current]':'isCurrent'
  },

  templateUrl: './datepicker-reply-years-view.html',
  styleUrls: ['./datepicker-reply-years-view.scss'],

})
export class NgbDatepickerReplyYearsViewNOA11Y implements OnInit, OnDestroy {
  
  @Input() currentMonth: number;
  @Input() year: NgbYearStruct;
  @Input() disabled: boolean;
  @Input() focused: boolean;
  @Input() selected: boolean;

  @Input() startDateEnabled: any;
  @Input() endDateEnabled: any;
  isCurrent : boolean = false;

  private _sub : Subscription;

  isMuted() { return false };

  ngOnInit(): void {
    const now = new Date();
    this.isCurrent = this.year.number === now.getFullYear();
    this.setSelected(this.service._model$.getValue());
  }

  setSelected(model : DatepickerViewModel) {
    // console.info('selected:year', model, this.year);
      if(model && model.selectedDate) {
        this.selected = this.year && model.selectedDate.year === this.year.number;
        return;
      }
      // console.info('selected:year no current, checking first');
      if(model && model.firstDate) {
        this.selected = this.year && model.firstDate.year === this.year.number;
      }
  }

  ngOnDestroy(): void {
    // if(this._sub) {
    //   this._sub.unsubscribe();
    // }
  }
  
  abilitaAnni(data) {

    if(this.startDateEnabled.year <= data.number && data.number <= this.endDateEnabled.year){
      return true
    }
     
    return false
    
  }

  constructor(private service : NgbDatepickerServiceNOA11Y) {
    // this._sub = this.service.model$.subscribe(this.setSelected);
  }
  // isMuted() { return !this.selected && (this.mese.number !== this.currentMonth || this.disabled); }

}
